# HG changeset patch
# User Remi Thebault <remi.thebault@gmail.com>
# Date 1604965942 -3600
#      Tue Nov 10 00:52:22 2020 +0100
# Node ID eea53507123172855b8607af37b35424eacdfada
# Parent  0e86e50bebeb1e73385b3d0ff374d7bfec093ad5
Initial implementation of Property Inspector


HIGHLIGHTS

  * a widget with two main views
    - a tree to display and interact with graphics object tree
    - a table, displaying the properties of the object selected in the
      tree

  * the tree receive notifications of graphics object creation/deletion
    to update itself

  * the table provides display and edition of most types of properties


SHORTCOMINGS

  * Not all property types have yet proper editors/painting

  * Updating properties does not always reflect in the figures.
    - updating line color for example not always trigger redraw.
    - when redraw happens, all previous property editions are visible

  * No link to help is provided. 2 possible strategies:
    - compute URL to online help from handle type and property name
    - embed the help in the executable. I have no clue how to do this.


DETAILED CHANGELOG

  * liboctave/util/oct-mutex.h
    - adding unique_lock template class that encapsulate a critical resource
      providing lock/unlock methods. unique_lock is moveable but non-copiable
      and also acts like a smart pointer.
      - not a strictly needed addition, but is used to provide safely the
        gh_manager instance to the GUI

  * libinterp/corefcn/graphics.in.h
    - adding some introspection of graphics properties
      - prop_type() method (returning new property_type enum)
      - as_base_property() method to retrieve a pointer that can be casted
      - as_[type]_property() that dynamic_cast the base property to derived
        type (not used - compiled out at the moment)

  * libinterp/corefcn/event-manager.h
    - adding lifetime events of graphics objects in the interpreter events
      interface. Needed to track creation and removal of graphics objects in
      the tree.

  * libinterp/corefcn/graphics.cc
   - fire the graphics objects lifetime events

  * libui/src/qt-interpreter-events.h
  * libui/src/qt-interpreter-events.cc
    - adding signals for the new graphics objects

  * libgui/src/interpreter-qobject.h
  * libgui/src/interpreter-qobject.cc
    - provide access to the gh_manager through a unique_lock
    - the GUI cannot use the gh_manager without locking it
    - Not very useful today because the gh_manager is not consistently locked
      in the interpreter thread (e.g. when setting/reading properties).
      This could lead to race conditions (although I didn't observe any).
    - May be a better strategy is to have fine grain (per property) locking.

  * libgui/src/property-inspector.h
  * libgui/src/property-inspector.cc
    - implementation of the property inspector
      - simple widget that instantiate the more complex views and models and
        make them talk together

  * libgui/src/property-inspector-tree.h
  * libgui/src/property-inspector-tree.cc
    - implementation of the graphics handle tree model
    - quite straightforward Qt tree model code

  * libgui/src/property-inspector-table.h
  * libgui/src/property-inspector-table.cc
    - implementation of the graphics properties table model and item delegate.
    - to keep code flexible, I tried to take the best decisions based on the
      octave_value of the property rather than based on the derived property
      type, but this is not always possible. (hence the properties
      introspection)
    - there are (at the moment) two QWidget subclasses used as cell editors:
      - matrix_widget
      - color_editor_widget (this one use a *.ui designer file)
    - QComboBox is used for the radio properties
    - default Qt implementation is used for plain strings and numbers

  * libgui/src/property-inspector-color-editor.ui
    - Qt Designer file for the color_editor_widget

  * libgui/src/main-window.h
  * libgui/src/main-window.cc
  * libgui/src/gui-preferences-sc.h
    - instantiate the property inspector and setup shortcuts

  * libgui/src/module.mk
    - adding new property inspector files

diff -r 0e86e50bebeb -r eea535071231 libgui/src/gui-preferences-sc.h
--- a/libgui/src/gui-preferences-sc.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/gui-preferences-sc.h	Tue Nov 10 00:52:22 2020 +0100
@@ -105,6 +105,7 @@ const sc_pref sc_main_window_show_worksp
 const sc_pref sc_main_window_show_editor (sc_main_window + ":show_editor", PRE + CTRL_SHIFT + Qt::Key_4);
 const sc_pref sc_main_window_show_doc (sc_main_window + ":show_doc", PRE + CTRL_SHIFT + Qt::Key_5);
 const sc_pref sc_main_window_show_variable_editor (sc_main_window + ":show_variable_editor", PRE + CTRL_SHIFT + Qt::Key_6);
+const sc_pref sc_main_window_show_property_inspector (sc_main_window + ":show_property_inspector", PRE + CTRL_SHIFT + Qt::Key_7);
 const sc_pref sc_main_window_command (sc_main_window + ":command", PRE + CTRL + Qt::Key_0);
 const sc_pref sc_main_window_history (sc_main_window + ":history", PRE + CTRL + Qt::Key_1);
 const sc_pref sc_main_window_file_browser (sc_main_window + ":file_browser", PRE + CTRL + Qt::Key_2);
@@ -112,6 +113,7 @@ const sc_pref sc_main_window_workspace (
 const sc_pref sc_main_window_editor (sc_main_window + ":editor", PRE + CTRL + Qt::Key_4);
 const sc_pref sc_main_window_doc (sc_main_window + ":doc", PRE + CTRL + Qt::Key_5);
 const sc_pref sc_main_window_variable_editor (sc_main_window + ":variable_editor", PRE + CTRL + Qt::Key_6);
+const sc_pref sc_main_window_property_inspector (sc_main_window + ":property_inspector", PRE + CTRL + Qt::Key_7);
 const sc_pref sc_main_window_previous_dock (sc_main_window + ":previous_widget", PRE + CTRL_ALT + Qt::Key_P);
 const sc_pref sc_main_window_reset (sc_main_window + ":reset", QKeySequence::UnknownKey);
 
diff -r 0e86e50bebeb -r eea535071231 libgui/src/interpreter-qobject.cc
--- a/libgui/src/interpreter-qobject.cc	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/interpreter-qobject.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -143,4 +143,13 @@ namespace octave
   {
     return m_octave_qobj.qt_link ();
   }
+
+  gh_manager_lock interpreter_qobject::get_gh_manager (void)
+  {
+    if (! m_interpreter)
+      throw std::logic_error ("interpreter_qobject::get_gh_manager called "
+                              "before initialization of interpreter");
+
+    return gh_manager_lock (m_interpreter->get_gh_manager ());
+  }
 }
diff -r 0e86e50bebeb -r eea535071231 libgui/src/interpreter-qobject.h
--- a/libgui/src/interpreter-qobject.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/interpreter-qobject.h	Tue Nov 10 00:52:22 2020 +0100
@@ -28,14 +28,22 @@
 
 #include <QObject>
 
+#include "oct-mutex.h"
+
 #include "qt-interpreter-events.h"
 
+
+class gh_manager;
+
 namespace octave
 {
+
   class interpreter;
 
   class base_qobject;
 
+  using gh_manager_lock = ::octave::unique_lock<gh_manager>;
+
   class interpreter_qobject : public QObject
   {
     Q_OBJECT
@@ -52,6 +60,8 @@ namespace octave
 
     void interpreter_event (const meth_callback& meth);
 
+    gh_manager_lock get_gh_manager ();
+
   signals:
 
     void ready (void);
diff -r 0e86e50bebeb -r eea535071231 libgui/src/main-window.cc
--- a/libgui/src/main-window.cc	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/main-window.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -107,13 +107,13 @@ namespace octave
 #endif
   }
 
-  main_window::main_window (base_qobject& oct_qobj)
-    : QMainWindow (), m_octave_qobj (oct_qobj),
-      m_workspace_model (nullptr),
+  main_window::main_window (base_qobject &oct_qobj)
+    : QMainWindow (), m_octave_qobj (oct_qobj), m_workspace_model (nullptr),
       m_status_bar (nullptr), m_command_window (nullptr),
       m_history_window (nullptr), m_file_browser_window (nullptr),
       m_doc_browser_window (nullptr), m_editor_window (nullptr),
       m_workspace_window (nullptr), m_variable_editor_window (nullptr),
+      m_property_inspector_window (nullptr),
       m_external_editor (new external_editor_interface (this, m_octave_qobj)),
       m_active_editor (m_external_editor), m_settings_dlg (nullptr),
       m_find_files_dlg (nullptr), m_set_path_dlg (nullptr),
@@ -176,6 +176,7 @@ namespace octave
     m_editor_window = create_default_editor (this, m_octave_qobj);
     m_variable_editor_window = new variable_editor (this, m_octave_qobj);
     m_workspace_window = new workspace_view (this, m_octave_qobj);
+    m_property_inspector_window = new property_inspector (this, m_octave_qobj);
 
     m_previous_dock = m_command_window;
 
@@ -253,6 +254,7 @@ namespace octave
     delete m_history_window;
     delete m_status_bar;
     delete m_variable_editor_window;
+    delete m_property_inspector_window;
 
     delete m_find_files_dlg;
     delete m_release_notes_window;
@@ -2084,6 +2086,8 @@ namespace octave
 #endif
     addDockWidget (Qt::RightDockWidgetArea, m_variable_editor_window);
     tabifyDockWidget (m_command_window, m_variable_editor_window);
+    addDockWidget(Qt::RightDockWidgetArea, m_property_inspector_window);
+    tabifyDockWidget (m_command_window, m_property_inspector_window);
 
     addDockWidget (Qt::LeftDockWidgetArea, m_file_browser_window);
     addDockWidget (Qt::LeftDockWidgetArea, m_workspace_window);
@@ -2601,8 +2605,13 @@ namespace octave
     m_show_documentation_action = construct_window_menu_item
       (window_menu, tr ("Show Documentation"), true, m_doc_browser_window);
 
-    m_show_variable_editor_action = construct_window_menu_item
-      (window_menu, tr ("Show Variable Editor"), true, m_variable_editor_window);
+    m_show_variable_editor_action
+        = construct_window_menu_item (window_menu, tr ("Show Variable Editor"),
+                                      true, m_variable_editor_window);
+
+    m_show_property_inspector_action = construct_window_menu_item (
+        window_menu, tr ("Show Property Inspector"), true,
+        m_property_inspector_window);
 
     window_menu->addSeparator ();
 
@@ -2627,6 +2636,10 @@ namespace octave
     m_variable_editor_action = construct_window_menu_item
       (window_menu, tr ("Variable Editor"), false, m_variable_editor_window);
 
+    m_property_inspector_action
+        = construct_window_menu_item (window_menu, tr ("Property Inspector"),
+                                      false, m_property_inspector_window);
+
     window_menu->addSeparator ();
 
     m_previous_dock_action = add_action (window_menu, QIcon (),
@@ -2792,6 +2805,7 @@ namespace octave
     scmgr.set_shortcut (m_show_editor_action, sc_main_window_show_editor);
     scmgr.set_shortcut (m_show_documentation_action, sc_main_window_show_doc);
     scmgr.set_shortcut (m_show_variable_editor_action, sc_main_window_show_variable_editor);
+    scmgr.set_shortcut (m_show_property_inspector_action, sc_main_window_show_property_inspector);
     scmgr.set_shortcut (m_command_window_action, sc_main_window_command);
     scmgr.set_shortcut (m_history_action, sc_main_window_history);
     scmgr.set_shortcut (m_workspace_action, sc_main_window_workspace);
@@ -2799,6 +2813,7 @@ namespace octave
     scmgr.set_shortcut (m_editor_action, sc_main_window_editor);
     scmgr.set_shortcut (m_documentation_action, sc_main_window_doc);
     scmgr.set_shortcut (m_variable_editor_action, sc_main_window_variable_editor);
+    scmgr.set_shortcut (m_property_inspector_action, sc_main_window_property_inspector);
     scmgr.set_shortcut (m_previous_dock_action, sc_main_window_previous_dock);
     scmgr.set_shortcut (m_reset_windows_action, sc_main_window_reset);
 
@@ -2828,6 +2843,8 @@ namespace octave
 #endif
     list.append (static_cast<octave_dock_widget *> (m_workspace_window));
     list.append (static_cast<octave_dock_widget *> (m_variable_editor_window));
+    list.append (
+        static_cast<octave_dock_widget *> (m_property_inspector_window));
     return list;
   }
 
diff -r 0e86e50bebeb -r eea535071231 libgui/src/main-window.h
--- a/libgui/src/main-window.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/main-window.h	Tue Nov 10 00:52:22 2020 +0100
@@ -55,6 +55,7 @@
 #include "interpreter-qobject.h"
 #include "octave-dock-widget.h"
 #include "octave-qobject.h"
+#include "property-inspector.h"
 #include "qt-interpreter-events.h"
 #include "set-path-dialog.h"
 #include "terminal-dock-widget.h"
@@ -319,6 +320,7 @@ namespace octave
     file_editor_interface *m_editor_window;
     workspace_view *m_workspace_window;
     variable_editor *m_variable_editor_window;
+    property_inspector *m_property_inspector_window;
     //!@}
 
     external_editor_interface *m_external_editor;
@@ -366,6 +368,7 @@ namespace octave
     QAction *m_show_editor_action;
     QAction *m_show_documentation_action;
     QAction *m_show_variable_editor_action;
+    QAction *m_show_property_inspector_action;
     QAction *m_command_window_action;
     QAction *m_history_action;
     QAction *m_workspace_action;
@@ -373,6 +376,7 @@ namespace octave
     QAction *m_editor_action;
     QAction *m_documentation_action;
     QAction *m_variable_editor_action;
+    QAction *m_property_inspector_action;
     QAction *m_previous_dock_action;
     QAction *m_reset_windows_action;
 
diff -r 0e86e50bebeb -r eea535071231 libgui/src/module.mk
--- a/libgui/src/module.mk	Sun Oct 25 19:28:08 2020 -0700
+++ b/libgui/src/module.mk	Tue Nov 10 00:52:22 2020 +0100
@@ -143,6 +143,9 @@ OCTAVE_GUI_SRC_MOC = \
   %reldir%/moc-main-window.cc \
   %reldir%/moc-news-reader.cc \
   %reldir%/moc-octave-qobject.cc \
+  %reldir%/moc-property-inspector.cc \
+  %reldir%/moc-property-inspector-table.cc \
+  %reldir%/moc-property-inspector-tree.cc \
   %reldir%/moc-settings-dialog.cc \
   %reldir%/moc-terminal-dock-widget.cc \
   %reldir%/moc-color-picker.cc \
@@ -173,6 +176,7 @@ DIRSTAMP_FILES += \
   %reldir%/$(octave_dirstamp)
 
 octave_gui_UI = \
+  %reldir%/property-inspector-color-editor.ui \
   %reldir%/settings-dialog.ui
 
 octave_gui_UI_H = $(patsubst %reldir%/%.ui, %reldir%/ui-%.h, $(octave_gui_UI))
@@ -220,6 +224,9 @@ noinst_HEADERS += \
   %reldir%/main-window.h \
   %reldir%/news-reader.h \
   %reldir%/octave-qobject.h \
+  %reldir%/property-inspector.h \
+  %reldir%/property-inspector-table.h \
+  %reldir%/property-inspector-tree.h \
   %reldir%/qt-application.h \
   %reldir%/qt-interpreter-events.h \
   %reldir%/qt-utils.h \
@@ -261,6 +268,9 @@ noinst_HEADERS += \
   %reldir%/news-reader.cc \
   %reldir%/octave-dock-widget.cc \
   %reldir%/octave-qobject.cc \
+  %reldir%/property-inspector.cc \
+  %reldir%/property-inspector-table.cc \
+  %reldir%/property-inspector-tree.cc \
   %reldir%/qt-interpreter-events.cc \
   %reldir%/qt-application.cc \
   %reldir%/resource-manager.cc \
diff -r 0e86e50bebeb -r eea535071231 libgui/src/property-inspector-color-editor.ui
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/libgui/src/property-inspector-color-editor.ui	Tue Nov 10 00:52:22 2020 +0100
@@ -0,0 +1,312 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>color_editor_widget</class>
+ <widget class="QWidget" name="color_editor_widget">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>277</width>
+    <height>179</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Form</string>
+  </property>
+  <layout class="QVBoxLayout" name="verticalLayout_3">
+   <property name="leftMargin">
+    <number>4</number>
+   </property>
+   <property name="topMargin">
+    <number>4</number>
+   </property>
+   <property name="rightMargin">
+    <number>4</number>
+   </property>
+   <property name="bottomMargin">
+    <number>0</number>
+   </property>
+   <item>
+    <widget class="QWidget" name="radioWgt" native="true">
+     <property name="sizePolicy">
+      <sizepolicy hsizetype="Preferred" vsizetype="Maximum">
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <layout class="QHBoxLayout" name="horizontalLayout_3">
+      <property name="leftMargin">
+       <number>0</number>
+      </property>
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <property name="rightMargin">
+       <number>0</number>
+      </property>
+      <property name="bottomMargin">
+       <number>0</number>
+      </property>
+      <item>
+       <widget class="QRadioButton" name="radioRad">
+        <property name="sizePolicy">
+         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="text">
+         <string>preset</string>
+        </property>
+       </widget>
+      </item>
+      <item>
+       <widget class="QComboBox" name="radioBox"/>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item>
+    <widget class="Line" name="line">
+     <property name="orientation">
+      <enum>Qt::Horizontal</enum>
+     </property>
+    </widget>
+   </item>
+   <item>
+    <widget class="QWidget" name="widget_5" native="true">
+     <layout class="QGridLayout" name="gridLayout">
+      <property name="leftMargin">
+       <number>0</number>
+      </property>
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <property name="rightMargin">
+       <number>0</number>
+      </property>
+      <property name="bottomMargin">
+       <number>0</number>
+      </property>
+      <item row="0" column="1">
+       <widget class="QWidget" name="rgbWgt1" native="true">
+        <layout class="QHBoxLayout" name="horizontalLayout_5">
+         <property name="leftMargin">
+          <number>0</number>
+         </property>
+         <property name="topMargin">
+          <number>0</number>
+         </property>
+         <property name="rightMargin">
+          <number>0</number>
+         </property>
+         <property name="bottomMargin">
+          <number>0</number>
+         </property>
+         <item>
+          <widget class="QLabel" name="rgbIcon">
+           <property name="minimumSize">
+            <size>
+             <width>80</width>
+             <height>0</height>
+            </size>
+           </property>
+           <property name="text">
+            <string/>
+           </property>
+           <property name="alignment">
+            <set>Qt::AlignCenter</set>
+           </property>
+          </widget>
+         </item>
+         <item>
+          <widget class="QPushButton" name="pickBtn">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="text">
+            <string>Pick</string>
+           </property>
+          </widget>
+         </item>
+        </layout>
+       </widget>
+      </item>
+      <item row="0" column="0">
+       <widget class="QRadioButton" name="rgbValRad">
+        <property name="sizePolicy">
+         <sizepolicy hsizetype="Maximum" vsizetype="Fixed">
+          <horstretch>0</horstretch>
+          <verstretch>0</verstretch>
+         </sizepolicy>
+        </property>
+        <property name="text">
+         <string>RBG</string>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="0" colspan="2">
+       <widget class="QWidget" name="rgbWgt2" native="true">
+        <layout class="QFormLayout" name="formLayout">
+         <property name="leftMargin">
+          <number>0</number>
+         </property>
+         <property name="topMargin">
+          <number>0</number>
+         </property>
+         <property name="rightMargin">
+          <number>0</number>
+         </property>
+         <property name="bottomMargin">
+          <number>0</number>
+         </property>
+         <item row="1" column="0">
+          <widget class="QLabel" name="label_2">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Preferred">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="text">
+            <string>Matrix</string>
+           </property>
+          </widget>
+         </item>
+         <item row="1" column="1">
+          <widget class="QWidget" name="widget" native="true">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Preferred" vsizetype="Maximum">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <layout class="QHBoxLayout" name="horizontalLayout">
+            <property name="leftMargin">
+             <number>0</number>
+            </property>
+            <property name="topMargin">
+             <number>0</number>
+            </property>
+            <property name="rightMargin">
+             <number>0</number>
+            </property>
+            <property name="bottomMargin">
+             <number>0</number>
+            </property>
+            <item>
+             <widget class="QDoubleSpinBox" name="rSpn">
+              <property name="decimals">
+               <number>3</number>
+              </property>
+              <property name="maximum">
+               <double>1.000000000000000</double>
+              </property>
+              <property name="singleStep">
+               <double>0.100000000000000</double>
+              </property>
+             </widget>
+            </item>
+            <item>
+             <widget class="QDoubleSpinBox" name="gSpn">
+              <property name="decimals">
+               <number>3</number>
+              </property>
+              <property name="maximum">
+               <double>1.000000000000000</double>
+              </property>
+              <property name="singleStep">
+               <double>0.100000000000000</double>
+              </property>
+             </widget>
+            </item>
+            <item>
+             <widget class="QDoubleSpinBox" name="bSpn">
+              <property name="decimals">
+               <number>3</number>
+              </property>
+              <property name="maximum">
+               <double>1.000000000000000</double>
+              </property>
+              <property name="singleStep">
+               <double>0.100000000000000</double>
+              </property>
+             </widget>
+            </item>
+           </layout>
+          </widget>
+         </item>
+         <item row="3" column="0">
+          <widget class="QLabel" name="label">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Maximum" vsizetype="Preferred">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <property name="text">
+            <string>SVG</string>
+           </property>
+          </widget>
+         </item>
+         <item row="3" column="1">
+          <widget class="QComboBox" name="svgBox">
+           <property name="minimumSize">
+            <size>
+             <width>100</width>
+             <height>0</height>
+            </size>
+           </property>
+           <property name="editable">
+            <bool>true</bool>
+           </property>
+          </widget>
+         </item>
+         <item row="2" column="0">
+          <widget class="QLabel" name="label_3">
+           <property name="text">
+            <string>Octave</string>
+           </property>
+          </widget>
+         </item>
+         <item row="2" column="1">
+          <widget class="QComboBox" name="octaveBox"/>
+         </item>
+        </layout>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item>
+    <widget class="QWidget" name="widget_2" native="true">
+     <property name="sizePolicy">
+      <sizepolicy hsizetype="Preferred" vsizetype="Maximum">
+       <horstretch>0</horstretch>
+       <verstretch>0</verstretch>
+      </sizepolicy>
+     </property>
+     <layout class="QHBoxLayout" name="horizontalLayout_2">
+      <property name="leftMargin">
+       <number>0</number>
+      </property>
+      <property name="topMargin">
+       <number>0</number>
+      </property>
+      <property name="rightMargin">
+       <number>0</number>
+      </property>
+      <property name="bottomMargin">
+       <number>0</number>
+      </property>
+     </layout>
+    </widget>
+   </item>
+  </layout>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
